/* (C) Peter Mueller / sinelabore.com */
/* Command line options: -U toggle.cfg -p CADIFRA -o toggle toggle.cdd   */
/* This file is generated from toggle.cdd - do not edit manually  */
/* Generated on: Thu Jan 01 23:23:39 CET 2015 / version 3.6.7 */


#include <stdint.h>
#include <msp430.h>
#include "../lib/timer.h"
#include "../lib/adc10.h"
#include "../tmp100.h"
#include "../i2c.h"
#include "toggle_ext.h"
#include "toggle.h"

extern FIFO_T buf1;
extern uint8_t timerId1;

uint16_t temperature;

void  toggle(TOGGLE_INSTANCEDATA_T *instanceVar, TOGGLE_EVENT_T msg){

	TOGGLE_EV_CONSUMED_FLAG_T evConsumed = 0U;

	
	/*execute entry code of default state once to init machine */
	if(instanceVar->runningEntry==1U){
		i2cInit();
		timerId1 = timerCreate(&buf1, evTimeout,false);
		P1OUT ^= BIT1;
		startTemperature();
		timerStart(timerId1,T500MS);
		P1OUT &= ~BIT1;
		

		instanceVar->runningEntry=0U;
	}


	switch (instanceVar->stateVar) {

		case Running:

			switch (instanceVar->stateVarRunning) {

				case Step1:
					if(msg==(TOGGLE_EVENT_T)evTimeout){
						/* Transition from Step1 to Step2 */
						evConsumed=1U;

						/* OnEntry code of state Step2 */
						P1OUT ^= BIT1;
						temperature = getTemperature();
						timerStart(timerId1, T1S);
						P1OUT &= ~BIT1;

						/* adjust state variables  */
						instanceVar->stateVarRunning = Step2;
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Step1  */

				case Step2:
					if(msg==(TOGGLE_EVENT_T)evTimeout){
						/* Transition from Step2 to Step1 */
						evConsumed=1U;

						/* OnEntry code of state Step1 */
						P1OUT ^= BIT1;
						startTemperature();
						timerStart(timerId1,T500MS);
						P1OUT &= ~BIT1;

						/* adjust state variables  */
						instanceVar->stateVarRunning = Step1;
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Step2  */

				default:
					/* Intentionally left blank */
				break;
			} /* end switch Running */

			/* Check if event was already processed  */
			if(evConsumed==0U){

				if(msg==(TOGGLE_EVENT_T)evPowerFail){
					/* Transition from Running to PowerFail */
					evConsumed=1U;
					
					/* Action code for transition  */
					timerStop(timerId1);


					P1OUT ^= BIT3;
					timerStart(timerId1,T100MS);
					instanceVar->stateVar = PowerFail;/* Default in entry chain  */
					instanceVar->stateVarPowerFail = PFLedHigh;/* Default in entry chain  */

				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			}
		break; /* end of case Running  */

		case PowerFail:

			switch (instanceVar->stateVarPowerFail) {

				case PFLedHigh:
					if(msg==(TOGGLE_EVENT_T)evTimeout){
						/* Transition from PFLedHigh to PFLedLow */
						evConsumed=1U;

						/* OnEntry code of state PFLedLow */
						P1OUT &= ~BIT3;
						timerStart(timerId1, T1S);

						/* adjust state variables  */
						instanceVar->stateVarPowerFail = PFLedLow;
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case PFLedHigh  */

				case PFLedLow:
					if(msg==(TOGGLE_EVENT_T)evTimeout){
						/* Transition from PFLedLow to PFLedHigh */
						evConsumed=1U;

						/* OnEntry code of state PFLedHigh */
						P1OUT ^= BIT3;
						timerStart(timerId1,T100MS);

						/* adjust state variables  */
						instanceVar->stateVarPowerFail = PFLedHigh;
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case PFLedLow  */

				default:
					/* Intentionally left blank */
				break;
			} /* end switch PowerFail */

			/* Check if event was already processed  */
			if(evConsumed==0U){

				if(msg==(TOGGLE_EVENT_T)evPowerOk){
					/* Transition from PowerFail to Running */
					evConsumed=1U;
					
					/* Action code for transition  */
					timerStop(timerId1);


					P1OUT ^= BIT1;
					startTemperature();
					timerStart(timerId1,T500MS);
					P1OUT &= ~BIT1;
					instanceVar->stateVar = Running;/* Default in entry chain  */
					instanceVar->stateVarRunning = Step1;/* Default in entry chain  */

				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			}
		break; /* end of case PowerFail  */

		default:
			/* Intentionally left blank */
		break;
	} /* end switch stateVar_root */
}

/* Implementation of the reset machine function */
void toggleResetMachine(TOGGLE_INSTANCEDATA_T *instanceVar){
	instanceVar->runningEntry = 1U;
	instanceVar->stateVar = Running;
	instanceVar->stateVarRunning = Step1;
	instanceVar->stateVarPowerFail = PFLedHigh;

}
// Helper(s) to reset history
void toggleResetHistoryRunning(TOGGLE_INSTANCEDATA_T *instanceVar){
	instanceVar->stateVarRunning=Step1;
}

void toggleResetHistoryPowerFail(TOGGLE_INSTANCEDATA_T *instanceVar){
	instanceVar->stateVarPowerFail=PFLedHigh;
}


// Helper(s) to find out if the machine is in a certain state

uint8_t toggleIsInPowerFail(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVar== PowerFail)) ? (1U) : (0U));
}

uint8_t toggleIsInPFLedHigh(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVarPowerFail== PFLedHigh)&&(instanceVar->stateVar== PowerFail)) ? (1U) : (0U));
}

uint8_t toggleIsInPFLedLow(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVarPowerFail== PFLedLow)&&(instanceVar->stateVar== PowerFail)) ? (1U) : (0U));
}

uint8_t toggleIsInStep1(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVarRunning== Step1)&&(instanceVar->stateVar== Running)) ? (1U) : (0U));
}

uint8_t toggleIsInStep2(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVarRunning== Step2)&&(instanceVar->stateVar== Running)) ? (1U) : (0U));
}

uint8_t toggleIsInRunning(TOGGLE_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVar== Running)) ? (1U) : (0U));
}


// Helper to get id of innermost active state
TOGGLE_STATES_T toggleGetInnermostActiveState(TOGGLE_INSTANCEDATA_T *instanceVar){
	if(toggleIsInStep2(instanceVar)){
		return Step2;
	}else if(toggleIsInStep1(instanceVar)){
		return Step1;
	}else if(toggleIsInPFLedLow(instanceVar)){
		return PFLedLow;
	}else if(toggleIsInPFLedHigh(instanceVar)){
		return PFLedHigh;
	}else{
		return __TOGGLE_LAST_STATE__;
	}
}

